(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('angular'), require('jquery')) :
  typeof define === 'function' && define.amd ? define(['angular', 'jquery'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global["ng-ovh-jquery-ui-draggable"] = factory(global.angular, global.$));
})(this, (function (angular, $) { 'use strict';

  function ___$insertStyle(css) {
      if (!css || typeof window === 'undefined') {
          return;
      }
      const style = document.createElement('style');
      style.setAttribute('type', 'text/css');
      style.innerHTML = css;
      document.head.appendChild(style);
      return css;
  }

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var angular__default = /*#__PURE__*/_interopDefaultLegacy(angular);
  var $__default = /*#__PURE__*/_interopDefaultLegacy($);

  function directive () {
    return {
      restrict: 'A',
      scope: false,
      link: function link(scope, el, attrs) {
        var privateAttr = {
          draggableSrcClonedClass: null
        };
        var obj = {
          draggableId: null,
          draggableInfo: null
        };
        var opts = angular__default["default"].isDefined(attrs.draggableOptions) ? scope.$eval(attrs.draggableOptions) : {};
        var evts = {};
        var options = null;
        function emitEvent(name, ui) {
          scope.$apply(function () {
            scope.$emit(name, {
              dragged: ui,
              draggable: obj
            });
          });
        }
        if (angular__default["default"].isDefined(attrs.draggableSrcClonedClass)) {
          privateAttr.draggableSrcClonedClass = attrs.draggableSrcClonedClass;
        }
        attrs.$observe('draggableInfo', function (draggableInfo) {
          if (draggableInfo) {
            obj.draggableInfo = scope.$eval(attrs.draggableInfo);
          }
        });
        attrs.$observe('draggableId', function (draggableId) {
          obj.draggableId = draggableId;
        });
        attrs.$observe('draggableDisabled', function (disabled) {
          if ($__default["default"](el).draggable) {
            $__default["default"](el).draggable({
              disabled: disabled === 'true'
            });
          }
        });
        evts = {
          drag: function drag(event, ui) {
            emitEvent('draggable.drag', ui);
          },
          start: function start(event, ui) {
            if (privateAttr.draggableSrcClonedClass) {
              scope.$apply(function () {
                $__default["default"](el).addClass(privateAttr.draggableSrcClonedClass);
              });
            }
            emitEvent('draggable.start', ui);
          },
          stop: function stop(event, ui) {
            if (privateAttr.draggableSrcClonedClass) {
              scope.$apply(function () {
                $__default["default"](el).removeClass(privateAttr.draggableSrcClonedClass);
              });
            }
            emitEvent('draggable.stop', ui);
          }
        };
        options = $__default["default"].extend({}, opts, evts);
        $__default["default"](el).draggable(options);
      }
    };
  }

  var moduleName = 'ngOvhJqueryUiDraggable';
  angular__default["default"].module(moduleName, []).directive('draggable', directive);

  return moduleName;

}));
//# sourceMappingURL=ng-ovh-jquery-ui-draggable.js.map
